      SUBROUTINE EXT_RADOMEH(KNBMESS,KNBMECR,CDTYPM,KNBWAG,
     &                    PLATN,PLATS,PLONO,PLONE,KPLEIN)
!-----------------------------------------------------------------------
!  auteur de revision : F. Guillaume
!  date de revision   : 17/03/2008
!  objet              : formats explicites d'ecriture dans OBSOUL
!                       pour mise en conofmite SOPRANO.
!  08/11/2012 :              rajout des cles pour les precipitations
!=======================================================================
      IMPLICIT LOGICAL(L)

#include "oulan_pardimo.h"
#include "oulan_yomtomv.h"
#include "oulan_yompin.h"
#include "oulan_yomdirs.h"
#include "oulan_yomnbob.h"
#include "oulan_yomdate.h"
#include "oulan_yomcsts.h"

      PARAMETER ( JP_NBX_PAR = 15       , JP_LONG_STRUCTURE = 191      )

      CHARACTER  CLLAT            *  12 , CLLON                   *   12
      CHARACTER  CDTYPM           *  10 , CL_NULL                 *    5

      CHARACTER  CL_TYPE_MESS     *  20 , CL_VERS_MESS            *   20
      CHARACTER  CL_MIN_DATE      *  14 , CL_MAX_DATE             *   14
      CHARACTER  CL_LAST_ARRIVED  *   1 , CL_LISTE_PARAM(1)       *   15
      CHARACTER  CL_LISTE_STAT(1) *   4 , CL_DONNEES(5,KNBMESS)   *   80

      CHARACTER  CL_FROM          *   1 , CL_ORDER               *    1
      CHARACTER  CL_BASE          *   1 , CL_WHERE               * 1023

      CHARACTER  CL_AUTORISATION  *  30
      INTEGER    I_PAS_DE_TPS , I_NB_PARAM , I_TYPE_SORTIE , I_NBRE_STAT
      INTEGER    I_CODE_RETOUR_EXT , I_NB_MESS
      INTEGER    I_CQ_BDM(JP_LONG_STRUCTURE,KNBMESS)
      REAL       Z_DONNEES(JP_LONG_STRUCTURE,KNBMESS)

      REAL  DL_MIN_LAT , DL_MAX_LAT
      REAL  DL_MIN_LON , DL_MAX_LON

      CHARACTER  CLINDIC          * 12
      INTEGER    IVNM(JP_NBX_PAR),IFLG(JP_NBX_PAR),INCQ(0:3)
      REAL       ZPOB(JP_NBX_PAR),ZPRL(JP_NBX_PAR),ZVAR(JP_NBX_PAR)


! ----------------------------------------------------------------------
! code pour realiser des sorties formatees  OBSOUL (SOPRANO)

      character entete * 84, wagon_prov * 34
      character wagon  * 34, fmt_final * 117
! ----------------------------------------------------------------------


#include "oulan_yomfthermo.h"
#include "oulan_yombitu.h"

      EW(T) = EXP( 60.22274788372                                    -
     &             27.60156807553*AMAX1(0.,SIGN(1.,273.16-T))        -
     &             ( 6822.400210096 -
     &               526.9788711908*AMAX1(0.,SIGN(1.,273.16-T)) )/T  -
     &             ALOG(T)*( 5.139266694451 -
     &               4.576133536908*AMAX1(0.,SIGN(1.,273.16-T)) )      )

! ----------------------------------------------------------------------
! code pour realiser des sorties formatees  OBSOUL (SOPRANO)

      entete = "(I4,1X,I2,1X,I9,1X,F9.5,1X,F10.5,1X,A12,1X,I8,1X,I6,1X"
      entete = trim(adjustl(entete)) // ",ES12.5,1X,I5,1X,I7,1X,I7,1X,"
      wagon_prov = "(I5,'(1X,I3,1X,3(ES12.5,1X),I11)')"                       
! ----------------------------------------------------------------------

      KNBMECR = 0
      KPLEIN  = 0

      CL_NULL = 'NULL'//CHAR(0)

      ZALTSY  = 500.

      INCQ(0) = 0
      INCQ(1) = 2
      INCQ(2) = 3
      INCQ(3) = 1

      IZERO   = 0
      ICQUN   = 1

!-----------------------------------------------------------------------

!  Initialisations des arguments de la fonction d'extraction
!  ---------------------------------------------------------

      CL_TYPE_MESS( 1:10) = CDTYPM
      CL_TYPE_MESS(11:20) = '          '
      CL_VERS_MESS        = '%                   '
      CL_AUTORISATION     = 'OPER                          '
      CL_LAST_ARRIVED     = 'Y'
      CL_LISTE_STAT(1)    = 'NULL'
      CL_LISTE_PARAM(1)   = 'NULL           '

      CL_WHERE            = " AND origine in('202','212','1202','1212')"
      CL_FROM             = '?'
      CL_ORDER            = '?'
      CL_BASE             = 'Y'

      I_PAS_DE_TPS        = 0
      I_NB_PARAM          = 0
      I_TYPE_SORTIE       = 3
      I_NBRE_STAT         = 0
      I_NB_MESS           = KNBMESS

!-----------------------------------------------------------------------

!  Extraction
!  ----------

      PRINT *,' '
      PRINT *,' Extraction des ',CDTYPM,' entre ',CDATDEB(1),
     &        ' et ',CDATFIN(1)
      PRINT *,' '

      CL_MIN_DATE = CDATDEB(1)
      CL_MAX_DATE = CDATFIN(1)

      DL_MIN_LAT  = PLATS
      DL_MAX_LAT  = PLATN
      DL_MIN_LON  = PLONO
      DL_MAX_LON  = PLONE

      CL_DONNEES  = ' '
      Z_DONNEES   = RABSI
      I_CQ_BDM    = NABSI

      CALL RDLLTDOMCLAUSE(
     &  CL_TYPE_MESS    , CL_VERS_MESS    , CL_MIN_DATE  , CL_MAX_DATE ,
     &  CL_AUTORISATION , CL_LAST_ARRIVED , I_PAS_DE_TPS , CL_NULL     ,
     &  I_NB_PARAM      , Z_DONNEES       , CL_DONNEES   , CL_NULL     , 
     &  I_TYPE_SORTIE   , I_NB_MESS       , DL_MIN_LAT   , DL_MAX_LAT  ,
     &  DL_MIN_LON      , DL_MAX_LON      , CL_NULL      , I_NBRE_STAT ,
     &  CL_FROM         , CL_WHERE        , CL_ORDER     , CL_BASE     ,
     &  I_CODE_RETOUR_EXT )

!      CALL RDLLTDOMAINDECOD( CL_TYPE_MESS , CL_VERS_MESS ,
!     &  CL_MIN_DATE , CL_MAX_DATE , CL_AUTORISATION ,
!     &  CL_LAST_ARRIVED , I_PAS_DE_TPS , CL_NULL ,
!     &  I_NB_PARAM , Z_DONNEES , CL_DONNEES , CL_NULL ,
!     &  I_TYPE_SORTIE , I_NB_MESS , DL_MIN_LAT , DL_MAX_LAT ,
!     &  DL_MIN_LON , DL_MAX_LON , CL_NULL , I_NBRE_STAT ,
!     &  I_CODE_RETOUR_EXT )

      PRINT *,' '
      PRINT *,' Fin de l''extraction '
      PRINT *,' '
      
      IF ( I_CODE_RETOUR_EXT.NE.0 .AND.
     &     I_CODE_RETOUR_EXT.NE.1       ) THEN
        PRINT 101,CDTYPM,I_CODE_RETOUR_EXT
 101    FORMAT(/,' Probleme lors de l''extraction des ',A10,
     &         ' I_CODE_RETOUR_EXT = ',I8,/)
        RETURN
      ENDIF

      IF ( I_NB_MESS.EQ.KNBMESS ) KPLEIN = I_NB_MESS
      IF ( NINIT.EQ.1 ) RETURN

!-----------------------------------------------------------------------

!  Traitements
!  -----------

      OBS_BCLE: DO JO=1,I_NB_MESS
        IF ( LCUTOFF .AND. 
     &       CL_DONNEES(1,JO)(1:14).GT.CDATFIN(4) ) CYCLE OBS_BCLE
        IRLN    = NABSO
        IOTP    = NABSO
        IOCH    = NABSO
        ZLAT    = RABSO
        ZLON    = RABSO
        IDAT    = NABSO
        IETM    = NABSO
        ZALT    = RABSO
        INLV    = NABSO
        IRFL    = 11111
        ISTD    = 0
        CLINDIC = " '        ' "
        CLLAT   = '            '
        CLLON   = '            '
        ICQLAT  = 1
        ICQLON  = 1
        ICQDAT  = 1
        ICQETM  = 1
        ICQALT  = 1

        DO JA=1,JP_NBX_PAR
          IVNM(JA) = NABSO
          ZPOB(JA) = RABSO
          ZPRL(JA) = RABSO
          ZVAR(JA) = RABSO
          IFLG(JA) = NABSO
        ENDDO

!  Saisie de la locomotive

        IOTP = NSYNOP
        ZLAT = Z_DONNEES(16,JO)
        ZLON = Z_DONNEES(17,JO)
        IF ( I_CQ_BDM(16,JO).EQ.2 .OR. I_CQ_BDM(17,JO).EQ.2 )
     &    CYCLE OBS_BCLE
        IOCH    = 0
        CALL OULAN_CAROBS(IOTP,CDTYPM,IZERO,IZERO,IZERO,ZLAT,IOCH)
        IITY = MOD( IOCH , 1000 )
        WRITE (CLLAT(2:11),'(F10.5)') ZLAT
        WRITE (CLLON(2:11),'(F10.5)') ZLON
        IDAT = NINT( Z_DONNEES(11,JO) ) * 10000  +
     &         NINT( Z_DONNEES(12,JO) ) * 100    +
     &         NINT( Z_DONNEES(13,JO) )
        IETM = NINT( Z_DONNEES(14,JO) ) * 10000  +
     &         NINT( Z_DONNEES(15,JO) ) * 100

        IF ( Z_DONNEES(3,JO).NE.RABSI .AND. 
     &       Z_DONNEES(4,JO).NE.RABSI       ) THEN
           IF (NINT(Z_DONNEES(3,JO))>=100) THEN
	       IINDIC = NINT(Z_DONNEES(3,JO )) *  100000
	   ELSE
               IINDIC = NINT(Z_DONNEES(3,JO)) * 1000000
	   ENDIF
           IINDIC = IINDIC + NINT(Z_DONNEES(4,JO))
           WRITE (CLINDIC(3:10),'(I8.8)') IINDIC
        ENDIF

!        IF ( Z_DONNEES(3,JO).NE.RABSI .AND. 
!     &       Z_DONNEES(4,JO).NE.RABSI       ) THEN
!          IINDIC = NINT( Z_DONNEES(3,JO) ) * 1000000  +
!     &             NINT( Z_DONNEES(4,JO) )
!          WRITE (CLINDIC(3:10),'(I8.8)') IINDIC
!        ENDIF

        IF ( Z_DONNEES(18,JO).NE.RABSI ) ZALT = Z_DONNEES(18,JO)

        IF ( I_CQ_BDM(16,JO).NE.NABSI ) ICQLAT = INCQ(I_CQ_BDM(16,JO))
        IF ( I_CQ_BDM(17,JO).NE.NABSI ) ICQLON = INCQ(I_CQ_BDM(17,JO))
        IF ( I_CQ_BDM(18,JO).NE.NABSI ) ICQALT = INCQ(I_CQ_BDM(18,JO))
        IF ( I_CQ_BDM(11,JO).NE.NABSI .AND. I_CQ_BDM(12,JO).NE.NABSI
     &       .AND. I_CQ_BDM(13,JO).NE.NABSI )
     &    ICQDAT = MAX0( INCQ(I_CQ_BDM(11,JO)) ,
     &             MAX0( INCQ(I_CQ_BDM(12,JO)) ,
     &                   INCQ(I_CQ_BDM(13,JO)) ) )
        IF ( I_CQ_BDM(14,JO).NE.NABSI .AND. I_CQ_BDM(15,JO).NE.NABSI )
     &    ICQETM = MAX0(INCQ(I_CQ_BDM(14,JO)),INCQ(I_CQ_BDM(15,JO)))
        IRFL = ICQALT*10000 + ICQETM*1000 + ICQDAT*100 + ICQLON*10 +
     &         ICQLAT

        IF ( Z_DONNEES(8,JO).NE.RABSI )
     &    ISTD = INT(Z_DONNEES(8,JO)+REPSILON)

        ZPSTA = RABSO
        ZPMER = RABSO
        ICQCV = 3

        IF ( Z_DONNEES(44,JO).NE.RABSI .AND. I_CQ_BDM(44,JO).NE.2 )
     &    ZPMER = Z_DONNEES(44,JO)

        IF ( Z_DONNEES(43,JO).NE.RABSI .AND.
     &       I_CQ_BDM(43,JO).NE.2             ) THEN
          ZPSTA = Z_DONNEES(43,JO)
          IF ( I_CQ_BDM(43,JO).NE.NABSI ) ICQCV = I_CQ_BDM(43,JO)
        ENDIF

        IPRESCD = 6
        IF ( ZPSTA.NE.RABSO ) THEN
          IPRESCD = 1
        ELSE IF ( ZPMER.NE.RABSO ) THEN
          IPRESCD = 0
        ELSE IF ( Z_DONNEES(47,JO).NE.RABSI ) THEN
          IF ( NINT(Z_DONNEES(47,JO)).EQ.85000. ) THEN
            IPRESCD = 2
          ELSE IF ( NINT(Z_DONNEES(47,JO)).EQ.70000. ) THEN
            IPRESCD = 3
          ELSE IF ( NINT(Z_DONNEES(47,JO)).EQ.90000. ) THEN
            IPRESCD = 9
          ELSE IF ( NINT(Z_DONNEES(47,JO)).EQ.100000. ) THEN
            IPRESCD = 10
          ELSE IF ( NINT(Z_DONNEES(47,JO)).EQ.50000. ) THEN
            IPRESCD = 11
          ELSE IF ( NINT(Z_DONNEES(47,JO)).EQ.92500. ) THEN
            IPRESCD = 12
          ENDIF
        ENDIF

        ISTD = ISTD + IPRESCD*100000

!  Saisie des wagons
!  -----------------

!  composition du code qualite (IFLG) :

!     bits 1 et 2   code qualite coordonnee verticale
!     bits 3 et 4   code qualite parametre mesure
!     bit     5     pression reduite au niveau de la mer
!     bit     6     pression station
!     bit     7     pression niveau barique 1000 hPa
!     bit     8     pression niveau barique  925 hPa
!     bit     9     pression niveau barique  900 hPa
!     bit    10     pression niveau barique  850 hPa
!     bit    11     pression niveau barique  700 hPa
!     bit    12     coordonnee verticale en Pascals
!     bit    13     coordonnee verticale en metres
!     bit    14     pression niveau barique  500 hPa

        INBP = 0

!  geopotentiel

        IF ( ( ZPMER.NE.RABSO.AND.ZALT.NE.RABSO.AND.ZALT.LT.ZALTSY )
     &  .OR. ( (IITY.EQ.NSHSCD.OR.IITY.EQ.NATSHS).AND.ZPMER.NE.RABSO )
     &     ) THEN
          INBP = INBP + 1
          IVNM(INBP) = NVNUMB(3)
          ZPOB(INBP) = - ZPMER
          ZVAR(INBP) = 0.
          ICQPA      = 3
          IF ( I_CQ_BDM(44,JO).NE.NABSI )  ICQPA = I_CQ_BDM(44,JO)
          IFLG(INBP) = 0
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQCV, 1)
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQPA, 3)
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQUN, 5)
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQUN,12)
        ELSE IF ( ZALT.NE.RABSO .AND. I_CQ_BDM(18,JO).NE.2 .AND.
     &                ZPSTA.NE.RABSO            ) THEN
          INBP = INBP + 1
          IVNM(INBP) = NVNUMB(3)
          ZPOB(INBP) = ZPSTA
          ZVAR(INBP) = ZALT * RG
          ICQPA      = 3
          IF ( I_CQ_BDM(18,JO).NE.NABSI ) ICQPA = I_CQ_BDM(18,JO)
          IFLG(INBP) = 0
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQCV, 1)
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQPA, 3)
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQUN, 6)
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQUN,12)
        ELSE IF ( ZALT.NE.RABSO .AND. I_CQ_BDM(18,JO).NE.2 .AND.
     &            Z_DONNEES(47,JO).NE.RABSI .AND.
     &            Z_DONNEES(48,JO).NE.RABSI .AND.
     &            I_CQ_BDM(47,JO).NE.2      .AND.
     &            I_CQ_BDM(48,JO).NE.2             ) THEN
          INBP = INBP + 1
          IVNM(INBP) = NVNUMB(3)
          ZPOB(INBP) = Z_DONNEES(47,JO)
          ZVAR(INBP) = Z_DONNEES(48,JO)
          ICQCVB     = 3
          ICQPA      = 3
          IF ( I_CQ_BDM(47,JO).NE.NABSI ) ICQCVB = I_CQ_BDM(47,JO)
          IF ( I_CQ_BDM(48,JO).NE.NABSI ) ICQPA  = I_CQ_BDM(48,JO)
          IFLG(INBP) = 0
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQCV, 1)
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQPA, 3)
          IF ( NINT(Z_DONNEES(47,JO)).EQ.100000 ) THEN
            IFLG(INBP) = KBITEC(IFLG(INBP),ICQUN,7)
          ELSE IF ( NINT(Z_DONNEES(47,JO)).EQ.92500 ) THEN
            IFLG(INBP) = KBITEC(IFLG(INBP),ICQUN,8)
          ELSE IF ( NINT(Z_DONNEES(47,JO)).EQ.90000 ) THEN
            IFLG(INBP) = KBITEC(IFLG(INBP),ICQUN,9)
          ELSE IF ( NINT(Z_DONNEES(47,JO)).EQ.85000 ) THEN
            IFLG(INBP) = KBITEC(IFLG(INBP),ICQUN,10)
          ELSE IF ( NINT(Z_DONNEES(47,JO)).EQ.70000 ) THEN
            IFLG(INBP) = KBITEC(IFLG(INBP),ICQUN,11)
          ELSE IF ( NINT(Z_DONNEES(47,JO)).EQ.50000 ) THEN
            IFLG(INBP) = KBITEC(IFLG(INBP),ICQUN,14)
          ENDIF
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQUN,12)
        ENDIF


!  Pmer 

        IF (ZPMER.NE.RABSO.AND.ZALT.NE.RABSO) THEN
          INBP = INBP + 1
          IVNM(INBP) = NVNUMB(70)
          ZPOB(INBP) = ZPSTA
          ZVAR(INBP) = ZPMER
          ICQPA      = 3
          IF ( I_CQ_BDM(44,JO).NE.NABSI )  ICQPA = I_CQ_BDM(44,JO)
          IFLG(INBP) = 0
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQCV, 1)
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQPA, 3)
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQUN, 5)
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQUN,12)
        ENDIF

!  temperature a 2m

        IF ( Z_DONNEES(52,JO).NE.RABSI.AND.I_CQ_BDM(52,JO).NE.2 ) THEN
          INBP = INBP + 1
          IVNM(INBP) = NVNUMB(10)
          ZPOB(INBP) = ZPSTA
          ZVAR(INBP) = Z_DONNEES(52,JO)
          ICQPA      = 3
          IF ( I_CQ_BDM(52,JO).NE.NABSI ) ICQPA = I_CQ_BDM(52,JO)
          IFLG(INBP) = 0
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQCV, 1)
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQPA, 3)
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQUN,12)
        ENDIF

!  humidite relative a 2m via la temperature du point de rosee a 2m
!  ajout de l'humidite specifique

        ZT  = RABSI
        ZTD = RABSI

        IF ( Z_DONNEES(52,JO).NE.RABSI .AND.
     &       Z_DONNEES(36,JO).NE.RABSI .AND.
     &       I_CQ_BDM(52,JO).NE.2      .AND.
     &       I_CQ_BDM(36,JO).NE.2      .AND.
     &           Z_DONNEES(36,JO).LE.Z_DONNEES(52,JO) ) THEN
          ZT   = Z_DONNEES(52,JO)
          ZTD  = Z_DONNEES(36,JO)
          INBP = INBP + 1
          IVNM(INBP) = NVNUMB(7)
          ZPOB(INBP) = ZPSTA
          ZVAR(INBP) = NINT( 100. * ( EW(ZTD) / EW(ZT) ) )
          ZHU        = ZVAR(INBP) / 100.
          ICQPA      = 3
          IF ( I_CQ_BDM(36,JO).NE.NABSI ) ICQPA = I_CQ_BDM(36,JO)
          IFLG(INBP) = 0
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQCV, 1)
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQPA, 3)
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQUN,12)
          IF ( LRH2Q .AND. ZPSTA.NE.RABSO ) THEN
            ZDELTA = MAX( 0. , SIGN(1.,RTT-ZT) )
            ZES    = FOEW(ZT,ZDELTA)
            ZESOP  = ZES / ZPSTA
            ZQS    = FOQS(ZESOP)
            ZQ     = FOQS(ZHU*ZESOP)
            ZHUEE  = 0.10
            ZQEEFH = ZQS * ZHUEE
!           ZTEE   = ...
!           ZQEEFT = FODQS(ZQS,ZESOP,FODLEW(ZT,ZDELTA))
!           ZQEEFT = ZQEEFT * ZHU * ZTEE
            INBP = INBP + 1
            IVNM(INBP) = NVNUMB(63)
            ZPRL(INBP) = ZQEEFH
            ZPOB(INBP) = ZPSTA
            ZVAR(INBP) = ZQ
            IFLG(INBP) = IFLG(INBP-1)
          ENDIF
        ENDIF

!  direction et force du vent

        IF ( Z_DONNEES(20,JO).NE.RABSI .AND.
     &       Z_DONNEES(21,JO).NE.RABSI .AND.
     &       Z_DONNEES(20,JO).NE.400.  .AND.
     &       I_CQ_BDM(20,JO).NE.2      .AND.
     &       I_CQ_BDM(21,JO).NE.2             ) THEN
          INBP = INBP + 1
          IVNM(INBP) = NVNUMB(56)
          ZPOB(INBP) = ZPSTA
          ZPRL(INBP) = Z_DONNEES(21,JO)
          ZVAR(INBP) = Z_DONNEES(20,JO)
          ICQPA      = 3
          IF ( I_CQ_BDM(20,JO).NE.NABSI ) ICQPA = I_CQ_BDM(21,JO)
          IFLG(INBP) = 0
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQCV, 1)
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQPA, 3)
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQUN,12)
        ENDIF

!  hauteur de la couche de neige

            IF ( Z_DONNEES(86,JO).NE.RABSI .AND.
     &           I_CQ_BDM(86,JO).NE.2             ) THEN
               INBP = INBP + 1
               IVNM(INBP) = NVNUMB(46)
               ZPOB(INBP) = ZPSTA
               ZVAR(INBP) = Z_DONNEES(86,JO)
               ICQPA      = 3
               IF ( I_CQ_BDM(86,JO).NE.NABSI ) ICQPA = I_CQ_BDM(86,JO)
               IFLG(INBP) = 0
               IFLG(INBP) = KBITEC(IFLG(INBP),ICQCV,1)
               IFLG(INBP) = KBITEC(IFLG(INBP),ICQPA,3)
               IFLG(INBP) = KBITEC(IFLG(INBP),ICQUN,12)
            ENDIF
!  precipitations

        IF ( Z_DONNEES(32,JO).NE.RABSI .AND.
     &       I_CQ_BDM(32,JO).NE.2 .and. LRR06H ) THEN
          INBP = INBP + 1
          IVNM(INBP) = NVNUMB(34)
          ZPOB(INBP) = ZPSTA
          ZPRL(INBP) = 6. * 3600.
          ZVAR(INBP) = Z_DONNEES(32,JO)
          ICQPA      = 3
          IF ( I_CQ_BDM(32,JO).NE.NABSI ) ICQPA = I_CQ_BDM(32,JO)
          IFLG(INBP) = 0
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQCV, 1)
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQPA, 3)
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQUN,12)
        ELSE IF ( Z_DONNEES(33,JO).NE.RABSI .AND.
     &            I_CQ_BDM(33,JO).NE.2 .and. LRR12H ) THEN
          INBP = INBP + 1
          IVNM(INBP) = NVNUMB(34)
          ZPOB(INBP) = ZPSTA
          ZPRL(INBP) = 12. * 3600.
          ZVAR(INBP) = Z_DONNEES(33,JO)
          ICQPA      = 3
          IF ( I_CQ_BDM(33,JO).NE.NABSI ) ICQPA = I_CQ_BDM(33,JO)
          IFLG(INBP) = 0
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQCV, 1)
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQPA, 3)
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQUN,12)
        ELSE IF ( Z_DONNEES(31,JO).NE.RABSI .AND.
     &            I_CQ_BDM(31,JO).NE.2 .and. LRR03H ) THEN
          INBP = INBP + 1
          IVNM(INBP) = NVNUMB(34)
          ZPOB(INBP) = ZPSTA
          ZPRL(INBP) = 3. * 3600.
          ZVAR(INBP) = Z_DONNEES(31,JO)
          ICQPA      = 3
          IF ( I_CQ_BDM(31,JO).NE.NABSI ) ICQPA = I_CQ_BDM(31,JO)
          IFLG(INBP) = 0
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQCV, 1)
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQPA, 3)
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQUN,12)
        ELSE IF ( Z_DONNEES(34,JO).NE.RABSI .AND.
     &            I_CQ_BDM(34,JO).NE.2 .and. LRR24H ) THEN
          INBP = INBP + 1
          IVNM(INBP) = NVNUMB(34)
          ZPOB(INBP) = ZPSTA
          ZPRL(INBP) = 24. * 3600.
          ZVAR(INBP) = Z_DONNEES(34,JO)
          ICQPA      = 3
          IF ( I_CQ_BDM(34,JO).NE.NABSI ) ICQPA = I_CQ_BDM(34,JO)
          IFLG(INBP) = 0
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQCV, 1)
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQPA, 3)
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQUN,12)
        ELSE IF ( Z_DONNEES(30,JO).NE.RABSI .AND.
     &            I_CQ_BDM(30,JO).NE.2 .and. LRR01H ) THEN
          INBP = INBP + 1
          IVNM(INBP) = NVNUMB(34)
          ZPOB(INBP) = ZPSTA
          ZPRL(INBP) = 3600.
          ZVAR(INBP) = Z_DONNEES(30,JO)
          ICQPA      = 3
          IF ( I_CQ_BDM(30,JO).NE.NABSI ) ICQPA = I_CQ_BDM(30,JO)
          IFLG(INBP) = 0
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQCV, 1)
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQPA, 3)
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQUN,12)
        ENDIF

        INLV = INBP
        IRLN = NCILET + INLV*NCILBO

!  Copie de l'observation sur le fichier d'obs.

        IF ( INBP.GT.0 ) THEN

           write(wagon,fmt=wagon_prov) INBP
	   fmt_final = trim(adjustl(entete))//trim(adjustl(wagon))//")"

          WRITE (NULOBI,fmt_final) IRLN,IOTP,IOCH,ZLAT,ZLON,CLINDIC,
     &                     IDAT,IETM,ZALT,INLV,IRFL,ISTD,
     &                     (IVNM(J),ZPOB(J),ZPRL(J),ZVAR(J),
     &                     IFLG(J),J=1,INBP)
          KNBMECR = KNBMECR + 1
          KNBWAG  = KNBWAG + INBP 

          IF ( L_GEOPOINTS ) THEN
            ITPM = MOD( IOCH , 1000 )
            WRITE (NULGEO,'(F11.5,F11.5,I5)') ZLON,ZLAT,ITPM
          ENDIF
        ENDIF

      ENDDO OBS_BCLE

!-----------------------------------------------------------------------

      RETURN
      END
