      SUBROUTINE EXT_SSMICE(KNBMESS,KNBMECR,CDTYPM,KNBWAG,
     &                      PLATN,PLATS,PLONO,PLONE,KNBSAT,KPLEIN)
!-----------------------------------------------------------------------
!  auteur de revision : F. Guillaume
!  date de revision   : 17/03/2008
!  objet              : formats explicites d'ecriture dans OBSOUL
!                       pour mise en conofmite SOPRANO.
!=======================================================================

      IMPLICIT LOGICAL(L)

#include "oulan_pardimo.h"
#include "oulan_yomtomv.h"
#include "oulan_yompin.h"
#include "oulan_yomdirs.h"
#include "oulan_yomnbob.h"
#include "oulan_yomdate.h"
#include "oulan_yomcsts.h"

      PARAMETER ( JP_NBX_PAR =  1      , JP_DIM_STRUCT = 16           )

      CHARACTER  CLLAT            * 12 , CLLON                     * 12
      CHARACTER  CDTYPM           * 10 , CL_NULL                   *  5

      CHARACTER  CL_TYPE_MESS     * 20 , CL_VERS_MESS              * 20
      CHARACTER  CL_MIN_DATE      * 14 , CL_MAX_DATE               * 14
      CHARACTER  CL_LAST_ARRIVED  *  1 , CL_LISTE_PARAM(1)         * 15
      CHARACTER  CL_LISTE_STAT(1) *  4 , CL_AUTORISATION           * 30
      CHARACTER                          CL_DONNEES(5,KNBMESS)     * 80
      INTEGER    I_PAS_DE_TPS , I_NB_PARAM , I_TYPE_SORTIE , I_NBRE_STAT
      INTEGER    I_CQ_BDM(JP_DIM_STRUCT,KNBMESS)
      INTEGER    KNBSAT(4)
      INTEGER    I_CODE_RETOUR_EXT , I_NB_MESS
      REAL       Z_DONNEES(JP_DIM_STRUCT,KNBMESS)

      REAL  DL_MIN_LAT , DL_MAX_LAT
      REAL  DL_MIN_LON , DL_MAX_LON

      CHARACTER CLINDIC*12,CLSATOUT(10)*3,CLNBSATOUT(10)*6
      INTEGER   ICODM(KNBMESS),IVNM(JP_NBX_PAR),IFLG(JP_NBX_PAR)
      INTEGER   INCQ(0:3),INBSATOUT(10)
      REAL      ZPOB(JP_NBX_PAR),ZPRL(JP_NBX_PAR),ZVAR(JP_NBX_PAR)

! ----------------------------------------------------------------------
! code pour realiser des sorties formatees  OBSOUL (SOPRANO)

      character entete * 84, wagon_prov * 34
      character wagon  * 34, fmt_final * 117
! ----------------------------------------------------------------------

#include "oulan_yombitu.h"


! ----------------------------------------------------------------------
! code pour realiser des sorties formatees  OBSOUL (SOPRANO)

      entete="(I4,1X,I2,1X,I9,1X,F9.5,1X,F10.5,1X,A12,1X,I8,1X,I6,1X"
      entete = trim(adjustl(entete)) // ",ES12.5,1X,I5,1X,I7,1X,I7,1X,"
      wagon_prov = "(I5,'(1X,I3,1X,3(ES12.5,1X),I11)')"                       
! ----------------------------------------------------------------------

      CL_NULL  = 'NULL'//CHAR(0)

      INCQ(0) = 0
      INCQ(1) = 2
      INCQ(2) = 3
      INCQ(3) = 1

      IZERO   = 0
      ICQUN   = 1

      DO J=1,10
        CLNBSATOUT(J) = '      '
        CLSATOUT(J)   = '   '
        INBSATOUT(J)  = 0
      ENDDO

      I_NB_SAT_OUT = 0

!-----------------------------------------------------------------------

!  Initialisations des arguments de la fonction d'extraction
!  ---------------------------------------------------------

      CL_TYPE_MESS( 1:10) = CDTYPM
      CL_TYPE_MESS(11:20) = '          '
      CL_VERS_MESS        = '%                   '
      CL_MIN_DATE         = CDATDEB(2)
      CL_MAX_DATE         = CDATFIN(2)
      CL_AUTORISATION     = 'OPER                          '
      CL_LAST_ARRIVED     = 'Y'
      CL_LISTE_STAT(1)    = 'NULL'
      CL_LISTE_PARAM(1)   = 'NULL           '

      I_PAS_DE_TPS        = 0
      I_NB_PARAM          = 0
      I_TYPE_SORTIE       = 3
      I_NBRE_STAT         = 0
      I_NB_MESS           = KNBMESS

      DL_MIN_LAT          = PLATS
      DL_MAX_LAT          = PLATN
      DL_MIN_LON          = PLONO
      DL_MAX_LON          = PLONE

      CL_DONNEES          = ' '
      Z_DONNEES           = RABSI
      I_CQ_BDM            = NABSI

      KNBMECR = 0
      KPLEIN  = 0

!-----------------------------------------------------------------------

!  Extraction
!  ----------

      PRINT *,' '
      PRINT *,' Extraction des ',CDTYPM
      PRINT *,' '

      CALL RDLLTDOMAINDECOD( CL_TYPE_MESS , CL_VERS_MESS , CL_MIN_DATE ,
     &                       CL_MAX_DATE , CL_AUTORISATION ,
     &                       CL_LAST_ARRIVED , I_PAS_DE_TPS ,
     &                       CL_NULL , I_NB_PARAM , Z_DONNEES ,
     &                       CL_DONNEES , CL_NULL , I_TYPE_SORTIE ,
     &                       I_NB_MESS , DL_MIN_LAT , DL_MAX_LAT ,
     &                       DL_MIN_LON , DL_MAX_LON , CL_NULL ,
     &                       I_NBRE_STAT , I_CODE_RETOUR_EXT )

      PRINT *,' '
      PRINT *,' Fin de l''extraction '
      PRINT *,' '

      IF ( I_CODE_RETOUR_EXT.NE.0 .AND.
     &     I_CODE_RETOUR_EXT.NE.1       ) THEN
         PRINT 101,CDTYPM,I_CODE_RETOUR_EXT
 101     FORMAT(/,' Probleme lors de l''extraction des ',A10,
     &          ' I_CODE_RETOUR_EXT = ',I2,/)
         RETURN
      ENDIF

      IF ( I_NB_MESS.EQ.KNBMESS ) KPLEIN = I_NB_MESS
      IF ( NINIT.EQ.1 ) RETURN

!-----------------------------------------------------------------------

!  Traitements
!  -----------

      BOUCLE_MESSAGE: DO JO=1,I_NB_MESS
        IF ( LSSMIECH ) THEN
          I_NB_MES_PAQ = NINT(Z_DONNEES(1,JO))
          INOL = (JO-1) / I_NB_MES_PAQ
          INOL = MOD( INOL+1 , NSSMISAUT+1 )
          INOC = MOD( JO , NSSMISAUT+1 )
          IF ( INOL*INOC.NE.1 ) CYCLE BOUCLE_MESSAGE
        ENDIF
        IF ( Z_DONNEES(15,JO).EQ.RABSI ) CYCLE BOUCLE_MESSAGE
        IRLN    = NABSO
        IOTP    = NABSO
        IOCH    = NABSO
        ZLAT    = RABSO
        ZLON    = RABSO
        IDAT    = NABSO
        IETM    = NABSO
        ZALT    = RABSO
        INLV    = NABSO
        IRFL    = 11111
        ISTD    = 0
        CLINDIC = " '        ' "
        CLLAT   = '            '
        CLLON   = '            '
        IRFL    = 11111
        DO JA=1,JP_NBX_PAR
          IVNM(JA) = NABSO
          ZPOB(JA) = RABSO
          ZPRL(JA) = RABSO
          ZVAR(JA) = RABSO
          IFLG(JA) = NABSO
        ENDDO

!  Saisie de la locomotive

        IOTP = NSATEM
        ZLAT = Z_DONNEES(13,JO)
        ZLON = Z_DONNEES(14,JO)
        WRITE (CLLAT(2:11),'(F10.5)') ZLAT
        WRITE (CLLON(2:11),'(F10.5)') ZLON

        CALL OULAN_CAROBS(IOTP,CDTYPM,IZERO,IZERO,IZERO,ZLAT,IOCH)

        IDAT = NINT( Z_DONNEES( 7,JO) ) * 10000  +
     &         NINT( Z_DONNEES( 8,JO) ) * 100    +
     &         NINT( Z_DONNEES( 9,JO) )
        IETM = NINT( Z_DONNEES(10,JO) ) * 10000  +
     &         NINT( Z_DONNEES(11,JO) ) * 100    +
     &         FLOOR( Z_DONNEES(12,JO) )

! identifiant satellite :  F13 --> 246
!                          F14 --> 247
!                          F15 --> 248
! temporairement, F15 est force a 247 pour homogeneite avec le CEPMMT (!!)

        IINDIC = 0
        IF ( Z_DONNEES(1,JO).NE.RABSI ) THEN
          IF ( NINT(Z_DONNEES(1,JO)).EQ.13 ) THEN
            CLINDIC(8:10) = '246'
            KNBSAT(1)     = KNBSAT(1) + 1
            IINDIC        = 246
          ELSE IF ( NINT(Z_DONNEES(1,JO)).EQ.14 ) THEN
            CLINDIC(8:10) = '247'
            KNBSAT(2)     = KNBSAT(2) + 1
            IINDIC        = 247
          ELSE IF ( NINT(Z_DONNEES(1,JO)).EQ.15 ) THEN
            CLINDIC(8:10) = '248'
            KNBSAT(3)     = KNBSAT(3) + 1
            IINDIC        = 248
          ELSE
            CLINDIC(8:10) = '250'
            KNBSAT(4)     = KNBSAT(4) + 1
            IINDIC        = 250
          ENDIF
          ILPREND = 0
          DO JSAT=1,MNBSATSEL(N_SSMICE)
            IF ( IINDIC.EQ.MNOSATSEL(N_SSMICE,JSAT) ) ILPREND = 1
          ENDDO
          IF ( ILPREND.EQ.0 ) THEN
            ILYEST = 0
            DO JSAT=1,I_NB_SAT_OUT
              IF ( CLINDIC(8:10).EQ.CLSATOUT(JSAT) ) ILYEST = JSAT
            ENDDO
            IF ( ILYEST.EQ.0 ) THEN
              I_NB_SAT_OUT = I_NB_SAT_OUT + 1
              IF ( I_NB_SAT_OUT.LE.10 ) THEN
                CLSATOUT(I_NB_SAT_OUT)  = CLINDIC(8:10)
                INBSATOUT(I_NB_SAT_OUT) = 1
              ENDIF
            ELSE IF ( ILYEST.LE.10 ) THEN
              INBSATOUT(ILYEST) = INBSATOUT(ILYEST) + 1
            ENDIF
            CYCLE BOUCLE_MESSAGE
          ENDIF
        ELSE
          CYCLE BOUCLE_MESSAGE
        ENDIF

        IF ( Z_DONNEES(5,JO).NE.RABSI )
     &    ISTD = INT(Z_DONNEES(5,JO)+REPSILON)

!  informations auxiliaires

! info 1  VAR : pourcentage de glace
!         FLG : numero attrubue a l'algorithme

        IVNM(1) = NVNUMB(59)
        ZVAR(1) = Z_DONNEES(15,JO)
        INLV    = 1
        IRLN    = NCILET + INLV*NCILBO

!  copie de l'observation sur le fichier d'obs.

        write(wagon,fmt=wagon_prov) INLV
	fmt_final = trim(adjustl(entete))//trim(adjustl(wagon))//")"

        WRITE (NULOBI,fmt_final) IRLN,IOTP,IOCH,ZLAT,ZLON,CLINDIC,
     &                           IDAT,IETM,ZALT,INLV,IRFL,ISTD,
     &                           IVNM,ZPOB,ZPRL,ZVAR,IFLG
     
        KNBMECR = KNBMECR + 1
        KNBWAG  = KNBWAG + 1
        IF ( L_GEOPOINTS ) 
     &    WRITE (NULGEO,'(F11.5,F11.5,I5)') ZLON,ZLAT,IINDIC
      ENDDO BOUCLE_MESSAGE
  
!-----------------------------------------------------------------------

!  Impressions
!  -----------

      DO J=1,10
        IF ( INBSATOUT(J).GT.0 )
     &    WRITE (CLNBSATOUT(J),'(I6)') INBSATOUT(J)
      ENDDO
      IF ( I_NB_SAT_OUT.GT.0 ) WRITE (NULOUT,201) CLSATOUT,CLNBSATOUT
 201  FORMAT(/,' Satellites extraits, non retenus : ',10(3X,A3,2X),/,
     &       36X,10(A6,2X))
!-----------------------------------------------------------------------

      RETURN
      END
