      SUBROUTINE EXT_TEMP(KNBMESS,KNBMECR,CDTYPM,CDTYPM2,KNBWAG,
     S                    PLATN,PLATS,PLONO,PLONE,KPLEIN)
!-----------------------------------------------------------------------
!  auteur de revision : F. Guillaume
!  date de revision   : 17/03/2008
!  objet              : formats explicites d'ecriture dans OBSOUL
!                       pour mise en conofmite SOPRANO.
!=======================================================================
      IMPLICIT LOGICAL(L)


#include "oulan_pardimo.h"
#include "oulan_yompin.h"
#include "oulan_yomtomv.h"
#include "oulan_yomdirs.h"
#include "oulan_yomnbob.h"
#include "oulan_yomdate.h"
#include "oulan_yomcsts.h"

      PARAMETER ( JP_NBX_PAR = 10000  )

      CHARACTER  CLLAT            *  12 , CLLON                 *   12
      CHARACTER  CDTYPM           *  10
      CHARACTER  CDTYPM2          *  10

      CHARACTER  CL_TYPE_MESS     * 20 , CL_VERS_MESS           *   20
      CHARACTER  CL_MIN_DATE      * 14 , CL_MAX_DATE            *   14
      CHARACTER  CL_LAST_ARRIVED  *  1 , CL_LISTE_PARAM(1)      *   15
      CHARACTER  CL_LISTE_STAT(1) *  4 , CL_DONNEES(5,KNBMESS)  *   80
      CHARACTER  CL_FROM          *  1 , CL_ORDER               * 1023
      CHARACTER  CL_BASE          *  1 , CL_WHERE               * 1023
      CHARACTER  CL_AUTORISATION  * 30
      INTEGER    I_PAS_DE_TPS , I_NB_PARAM , I_TYPE_SORTIE , I_NBRE_STAT
      INTEGER    I_CQ_BDM(1200,KNBMESS),I_CODE_RETOUR_EXT , I_NB_MESS
      REAL       Z_DONNEES(1200,KNBMESS)

      REAL  DL_MIN_LAT , DL_MAX_LAT
      REAL  DL_MIN_LON , DL_MAX_LON

      CHARACTER  CLINDIC*12 , CLINDIC_PREC*12
      INTEGER    IVNM(JP_NBX_PAR),IFLG(JP_NBX_PAR),INCQ(0:3)
      REAL       ZPOB(JP_NBX_PAR),ZPRL(JP_NBX_PAR),ZVAR(JP_NBX_PAR)

      REAL       ZPSTD(19)

! ----------------------------------------------------------------------
! code pour realiser des sorties formatees  OBSOUL (SOPRANO)

      character entete * 84, wagon_prov * 34
      character wagon  * 34, fmt_final * 117
! ----------------------------------------------------------------------


#include "oulan_yomfthermo.h"
#include "oulan_yombitu.h"

      EW(T) = EXP( 60.22274788372
     &             - 6822.400210096/T - 5.139266694451*ALOG(T) )

! ----------------------------------------------------------------------
! code pour realiser des sorties formatees  OBSOUL (SOPRANO)

      entete = "(I4,1X,I2,1X,I9,1X,F9.5,1X,F10.5,1X,A12,1X,I8,1X,I6,1X"
      entete = trim(adjustl(entete)) // ",ES12.5,1X,I5,1X,I7,1X,I7,1X,"
      wagon_prov = "(I5,'(1X,I3,1X,3(ES12.5,1X),I11)')"                       
! ----------------------------------------------------------------------

      KNBMECR = 0
      KPLEIN  = 0

      INCQ(0) = 0
      INCQ(1) = 2
      INCQ(2) = 3
      INCQ(3) = 1

      IZERO   = 0
      ICQUN   = 1

      ZPSTD( 1) = 100000.
      ZPSTD( 2) =  95000.
      ZPSTD( 3) =  92500.
      ZPSTD( 4) =  90000.
      ZPSTD( 5) =  85000.
      ZPSTD( 6) =  70000.
      ZPSTD( 7) =  60000.
      ZPSTD( 8) =  50000.
      ZPSTD( 9) =  40000.
      ZPSTD(10) =  30000.
      ZPSTD(11) =  25000.
      ZPSTD(12) =  20000.
      ZPSTD(13) =  15000.
      ZPSTD(14) =  10000.
      ZPSTD(15) =   7000.
      ZPSTD(16) =   5000.
      ZPSTD(17) =   3000.
      ZPSTD(18) =   2000.
      ZPSTD(19) =   1000.

      ICUTOFF = 1
      IF ( CDTYPM.NE.'TEMP      ' ) ICUTOFF = 2

!-----------------------------------------------------------------------

!  Initialisations des arguments de la fonction d'extraction
!  ---------------------------------------------------------

      CL_TYPE_MESS( 1:10) = CDTYPM
      IF (LASCII) CL_TYPE_MESS( 1:10) = CDTYPM2
      CL_TYPE_MESS(11:20) = '          '
      CL_VERS_MESS        = '%                   '
      CL_MIN_DATE         = CDATDEB(2)
      CL_MAX_DATE         = CDATFIN(2)

      CL_AUTORISATION     = 'OPER                          '
      CL_LAST_ARRIVED     = 'Y'
      CL_LISTE_STAT(1)    = 'NULL'
      CL_LISTE_PARAM(1)   = 'NULL           '

      CL_WHERE            = '?'
      CL_FROM             = '?'
      CL_ORDER            = '?'
      CL_BASE             = 'Y'

      I_PAS_DE_TPS        = 0
      I_NB_PARAM          = 0
      I_TYPE_SORTIE       = 3
      I_NBRE_STAT         = 0
      I_NB_MESS           = KNBMESS

      DL_MIN_LAT          = PLATS
      DL_MAX_LAT          = PLATN
      DL_MIN_LON          = PLONO
      DL_MAX_LON          = PLONE

      CL_DONNEES          = ' '
      Z_DONNEES           = RABSI
      I_CQ_BDM            = NABSI

      IDAT_PREC           = NABSO
      IETM_PREC           = NABSO
      CLINDIC_PREC        = '            '

!-----------------------------------------------------------------------

!  Extraction
!  ----------

      PRINT *,' '
      PRINT *,' Extraction des ',CL_TYPE_MESS( 1:10)
      PRINT *,' '

      IF ( LCUTOFF ) THEN

         CL_LAST_ARRIVED = 'N'
         CL_WHERE  = ' AND DATE_INSERT < ''' // CDATFIN(4) // ''' '
         CL_ORDER  = ' ORDER BY DAT, LLTBUFR_VAL, AMENDMENT DESC '
 
         CALL RDLLTDOMCLAUSE( 
     &                CL_TYPE_MESS , CL_VERS_MESS , CL_MIN_DATE ,
     &                CL_MAX_DATE , CL_AUTORISATION ,
     &                CL_LAST_ARRIVED , I_PAS_DE_TPS ,
     &                CL_LISTE_PARAM , I_NB_PARAM , Z_DONNEES ,
     &                CL_DONNEES , I_CQ_BDM , I_TYPE_SORTIE ,
     &                I_NB_MESS , DL_MIN_LAT , DL_MAX_LAT ,
     &                DL_MIN_LON , DL_MAX_LON , CL_LISTE_STAT ,
     &                I_NBRE_STAT , CL_FROM , CL_WHERE ,
     &                CL_ORDER , CL_BASE , I_CODE_RETOUR_EXT )
      ELSE
         CALL RDLLTDOMAINDECOD(
     &                CL_TYPE_MESS , CL_VERS_MESS , CL_MIN_DATE ,
     &                CL_MAX_DATE , CL_AUTORISATION ,
     &                CL_LAST_ARRIVED , I_PAS_DE_TPS ,
     &                CL_LISTE_PARAM , I_NB_PARAM , Z_DONNEES ,
     &                CL_DONNEES , I_CQ_BDM , I_TYPE_SORTIE ,
     &                I_NB_MESS , DL_MIN_LAT , DL_MAX_LAT ,
     &                DL_MIN_LON , DL_MAX_LON , CL_LISTE_STAT ,
     &                I_NBRE_STAT , I_CODE_RETOUR_EXT )
      ENDIF

      PRINT *,' '
      PRINT *,' Fin de l''extraction '
      PRINT *,' '

      IF ( I_CODE_RETOUR_EXT.NE.0 .AND.
     &     I_CODE_RETOUR_EXT.NE.1       ) THEN
        PRINT 101,CDTYPM,I_CODE_RETOUR_EXT
 101    FORMAT(/,' Probleme lors de l''extraction des ',A10,
     &         ' I_CODE_RETOUR_EXT = ',I2,/)
        RETURN
      ENDIF

      IF ( I_NB_MESS.EQ.KNBMESS ) KPLEIN = I_NB_MESS
      IF ( NINIT.EQ.1 ) RETURN

!-----------------------------------------------------------------------

!  Traitements
!  -----------

      OBS_BCLE: DO JO=1,I_NB_MESS

        IRLN    = NABSO
        IOTP    = NABSO
        IOCH    = NABSO
        ZLAT    = RABSO
        ZLON    = RABSO
        IDAT    = NABSO
        IETM    = NABSO
        ZALT    = RABSO
        INLV    = NABSO
        IRFL    = 11111
        ISTD    = 0
        CLINDIC = " '        ' "
        CLLAT   = '            '
        CLLON   = '            '
        ICQLAT  = 1
        ICQLON  = 1
        ICQDAT  = 1
        ICQETM  = 1
        ICQALT  = 1

        DO JA=1,JP_NBX_PAR
          IVNM(JA) = NABSO
          ZPOB(JA) = RABSO
          ZPRL(JA) = RABSO
          ZVAR(JA) = RABSO
          IFLG(JA) = NABSO
        ENDDO

!  Saisie de la locomotive

        IOTP = NTEMP
        ZLAT = Z_DONNEES(19,JO)
        ZLON = Z_DONNEES(20,JO)
        IF ( I_CQ_BDM(19,JO).EQ.2 .OR. I_CQ_BDM(20,JO).EQ.2 )
     &    CYCLE OBS_BCLE
        WRITE (CLLAT(2:11),'(F10.5)') ZLAT
        WRITE (CLLON(2:11),'(F10.5)') ZLON
        IOCH   = 0
        ITYPRS = 255
        IF (Z_DONNEES(12,JO).NE.RABSI) ITYPRS = NINT(Z_DONNEES(12,JO))
        CALL OULAN_CAROBS(IOTP,CDTYPM,ITYPRS,IZERO,IZERO,ZLAT,IOCH)
        IDAT   = NINT( Z_DONNEES(14,JO) ) * 10000  +
     &           NINT( Z_DONNEES(15,JO) ) * 100    +
     &           NINT( Z_DONNEES(16,JO) )
        IETM = NINT( Z_DONNEES(17,JO) ) * 10000  +
     &         NINT( Z_DONNEES(18,JO) ) * 100
        IF ( Z_DONNEES(3,JO).EQ.RABSI ) THEN
          IINDIC = NINT( Z_DONNEES(1,JO) ) * 1000  +
     &             NINT( Z_DONNEES(2,JO) )
          WRITE (CLINDIC(3:7),'(I5.5)') IINDIC
        ELSE
          IVALCL = NINT( Z_DONNEES(3,JO) )
          INOCL  = IVALCL / 1000
          ILNCL  = MOD( IVALCL , 1000 )
          IF ( ILNCL.GE.8 ) THEN
            CLINDIC(3:10) = CL_DONNEES(INOCL,JO)(1:8)
          ELSE
            CLINDIC(3:2+ILNCL) = CL_DONNEES(INOCL,JO)(1:ILNCL)
          ENDIF
        ENDIF

        IF (LCUTOFF .AND.
     &      IDAT_PREC==IDAT .AND. IETM_PREC==IETM .AND.
     &      CLINDIC_PREC==CLINDIC) 
     &  CYCLE OBS_BCLE 

        IF ( Z_DONNEES(21,JO).NE.RABSI ) ZALT = Z_DONNEES(21,JO)

        IF ( I_CQ_BDM(19,JO).NE.NABSI ) ICQLAT = INCQ(I_CQ_BDM(19,JO))
        IF ( I_CQ_BDM(20,JO).NE.NABSI ) ICQLON = INCQ(I_CQ_BDM(20,JO))
        IF ( I_CQ_BDM(21,JO).NE.NABSI ) ICQALT = INCQ(I_CQ_BDM(21,JO))
        IF ( I_CQ_BDM(14,JO).NE.NABSI .AND. I_CQ_BDM(15,JO).NE.NABSI
     &       .AND. I_CQ_BDM(16,JO).NE.NABSI )
     &    ICQDAT = MAX0( INCQ(I_CQ_BDM(14,JO)) ,
     &                   MAX0( INCQ(I_CQ_BDM(15,JO)) ,
     &                         INCQ(I_CQ_BDM(16,JO)) ) )
        IF ( I_CQ_BDM(17,JO).NE.NABSI .AND. I_CQ_BDM(18,JO).NE.NABSI )
     &    ICQETM = MAX0(INCQ(I_CQ_BDM(17,JO)),INCQ(I_CQ_BDM(18,JO)))
        IRFL = ICQALT*10000 + ICQETM*1000 + ICQDAT*100 + ICQLON*10 +
     &         ICQLAT

        IF ( Z_DONNEES(7,JO).NE.RABSI )
     &    ISTD = INT(Z_DONNEES(7,JO)+REPSILON)

!  Saisie des wagons

!  composition du code qualite (IFLG) :

!     bits 1 et 2   code qualite coordonnee verticale
!     bits 3 et 4   code qualite parametre mesure
!     bit     5     niveau significatif en vent
!     bit     6     niveau significatif en temperature
!     bit     7     niveau de vent maximal
!     bit     8     niveau tropopause
!     bit     9     niveau standard
!     bit    10     niveau de surface
!     bit    11     information manquante
!     bit    12     coordonnee verticale en Pascals
!     bit    13     coordonnee verticale en metres
!     bits 14 et 15 = 0 si partie A
!                   = 1 si partie B
!                   = 2 si partie C
!                   = 3 si partie D

        INBNIV = INT( Z_DONNEES(33,JO) )
        IF ( INBNIV.EQ.0 .OR. INBNIV.EQ.NABSI ) CYCLE OBS_BCLE
        INBP = 0

!  temperature de surface de la mer

        IF ( Z_DONNEES(32,JO).NE.RABSI .AND.
     S       I_CQ_BDM(32,JO).NE.2             ) THEN
          INBP = INBP + 1
          IVNM(INBP) = NVNUMB(12)
          ZVAR(INBP) = Z_DONNEES(32,JO)
          ICQCV      = 3
          ICQPA      = 3
          IPART      = 1
          IF ( I_CQ_BDM(32,JO).NE.NABSI ) ICQPA = I_CQ_BDM(32,JO)
          IFLG(INBP) = 0
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQCV, 1)
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQPA, 3)
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQUN,10)
          IFLG(INBP) = KBITEC(IFLG(INBP),ICQUN,12)
          IFLG(INBP) = KBITEC(IFLG(INBP),IPART,14)
        ENDIF

        PAR_BCLE: DO JN=1,INBNIV
          ID = 33 + (JN-1)*7
          IF ( Z_DONNEES(ID+1,JO).EQ.RABSI .OR.
     &         I_CQ_BDM(ID+1,JO).EQ.2               ) CYCLE PAR_BCLE
          ZPNIV = Z_DONNEES(ID+1,JO)
          ICQNV = INT(Z_DONNEES(ID+2,JO))
          INSTD = KBITLU(ICQNV,6,1)
          ISURF = KBITLU(ICQNV,7,1)
          IF ( ZPNIV.GE.10000. ) THEN
            IF ( INSTD.EQ.1 ) THEN
              IPART = 0
            ELSE
              IPART = 1
            ENDIF
          ELSE
            IF ( INSTD.EQ.1 ) THEN
              IPART = 2
            ELSE
              IPART = 3
            ENDIF
          ENDIF
          ICQCV = 3
          IF ( I_CQ_BDM(ID+1,JO).NE.NABSI ) ICQCV = I_CQ_BDM(ID+1,JO)

!  geopotentiel

          IF ( Z_DONNEES(ID+3,JO).NE.RABSI .AND.
     &         I_CQ_BDM(ID+3,JO).NE.2             ) THEN
            INBP = INBP + 1
            IVNM(INBP) = NVNUMB(3)
            ZPOB(INBP) = ZPNIV
            ZPRL(INBP) = RABSO
            ZVAR(INBP) = Z_DONNEES(ID+3,JO)
            ICQPA      = 3
            IF ( I_CQ_BDM(ID+3,JO).NE.NABSI )
     &           ICQPA = I_CQ_BDM(ID+3,JO)
            IFLG(INBP) = 0
            IFLG(INBP) = KBITEC(IFLG(INBP),ICQCV, 1)
            IFLG(INBP) = KBITEC(IFLG(INBP),ICQPA, 3)
!FGFG
            IFLG(INBP) = KBITEC(IFLG(INBP),ICQNV,4)
!FGFG
!            IFLG(INBP) = KBITEC(IFLG(INBP),ICQNV, 5)
            IFLG(INBP) = KBITEC(IFLG(INBP),ICQUN,12)
            IFLG(INBP) = KBITEC(IFLG(INBP),IPART,14)
          ENDIF

!  temperature

          IF ( Z_DONNEES(ID+4,JO).NE.RABSI .AND.
     &         I_CQ_BDM(ID+4,JO).NE.2             ) THEN
            INBP = INBP + 1
            IF ( ISURF.EQ.1 ) THEN
              IVNM(INBP) = NVNUMB(10)
            ELSE
              IVNM(INBP) = NVNUMB(8)
            ENDIF
            ZPOB(INBP) = ZPNIV
            ZVAR(INBP) = Z_DONNEES(ID+4,JO)
            ICQPA      = 3
            IF ( I_CQ_BDM(ID+4,JO).NE.NABSI )
     &           ICQPA = I_CQ_BDM(ID+4,JO)
            IFLG(INBP) = 0
            IFLG(INBP) = KBITEC(IFLG(INBP),ICQCV, 1)
            IFLG(INBP) = KBITEC(IFLG(INBP),ICQPA, 3)
!FGFG
            IFLG(INBP) = KBITEC(IFLG(INBP),ICQNV,4)
!FGFG
!            IFLG(INBP) = KBITEC(IFLG(INBP),ICQNV, 5)
            IFLG(INBP) = KBITEC(IFLG(INBP),ICQUN,12)
            IFLG(INBP) = KBITEC(IFLG(INBP),IPART,14)
          ENDIF

!  humidite relative via la temperature du point de rosee
!  ajout de l'humidite specifique

          ZT  = RABSI
          ZTD = RABSI

          IF ( Z_DONNEES(ID+4,JO).NE.RABSI .AND.
     &         Z_DONNEES(ID+5,JO).NE.RABSI .AND.
     &         I_CQ_BDM(ID+4,JO).NE.2       .AND.
     &         I_CQ_BDM(ID+5,JO).NE.2       .AND.
     &         Z_DONNEES(ID+5,JO).LE.Z_DONNEES(ID+4,JO) ) THEN
            ZT   = Z_DONNEES(ID+4,JO)
            ZTD  = Z_DONNEES(ID+5,JO)
            INBP = INBP + 1
            IF ( ISURF.EQ.1 ) THEN
              IVNM(INBP) = NVNUMB(7)
            ELSE
              IVNM(INBP) = NVNUMB(5)
            ENDIF
            ZPOB(INBP) = ZPNIV
            ZVAR(INBP) = NINT( 100. * ( EW(ZTD) / EW(ZT) ) )
            ZHU        = ZVAR(INBP) / 100.
            ICQPA      = 3
            IF ( I_CQ_BDM(ID+5,JO).NE.NABSI )
     &        ICQPA = I_CQ_BDM(ID+5,JO)
            IFLG(INBP) = 0
            IFLG(INBP) = KBITEC(IFLG(INBP),ICQCV, 1)
            IFLG(INBP) = KBITEC(IFLG(INBP),ICQPA, 3)
!FGFG
            IFLG(INBP) = KBITEC(IFLG(INBP),ICQNV,4)
!FGFG
!            IFLG(INBP) = KBITEC(IFLG(INBP),ICQNV, 5)
            IFLG(INBP) = KBITEC(IFLG(INBP),ICQUN,12)
            IFLG(INBP) = KBITEC(IFLG(INBP),IPART,14)
            IF ( LRH2Q ) THEN
              ZDELTA = MAX( 0. , SIGN(1.,RTT-ZT) )
              ZES    = FOEW(ZT,ZDELTA)
              ZESOP  = ZES / ZPNIV
              ZQS    = FOQS(ZESOP)
              ZQ     = FOQS(ZHU*ZESOP)
              ZHUEE  = 0.14
              ZQEEFH = ZQS * ZHUEE
!             ZTEE   = ...
!             ZQEEFT = FODQS(ZQS,ZESOP,FODLEW(ZT,ZDELTA))
!             ZQEEFT = ZQEEFT * ZHU * ZTEE
              INBP = INBP + 1
              IVNM(INBP) = NVNUMB(63)
              ZPRL(INBP) = ZQEEFH
              ZPOB(INBP) = ZPNIV
              ZVAR(INBP) = ZQ
              IFLG(INBP) = IFLG(INBP-1)
            ENDIF
          ENDIF

!  direction et force du vent

          IF ( Z_DONNEES(ID+6,JO).NE.RABSI .AND.
     &         Z_DONNEES(ID+7,JO).NE.RABSI .AND.
     &         Z_DONNEES(ID+6,JO).NE.400.   .AND.
     &         I_CQ_BDM(ID+6,JO).NE.2       .AND.
     &         I_CQ_BDM(ID+7,JO).NE.2             ) THEN
            INBP = INBP + 1
            IF ( ISURF.EQ.1 ) THEN
              IVNM(INBP) = NVNUMB(56)
            ELSE
              IVNM(INBP) = NVNUMB(1)
            ENDIF
            ZPOB(INBP) = ZPNIV
            ZPRL(INBP) = Z_DONNEES(ID+7,JO)
            ZVAR(INBP) = Z_DONNEES(ID+6,JO)
            ICQPA      = 3
            IF ( I_CQ_BDM(ID+6,JO).NE.NABSI )
     &        ICQPA = I_CQ_BDM(ID+6,JO)
            IFLG(INBP) = 0
            IFLG(INBP) = KBITEC(IFLG(INBP),ICQCV, 1)
            IFLG(INBP) = KBITEC(IFLG(INBP),ICQPA, 3)
!FGFG
            IFLG(INBP) = KBITEC(IFLG(INBP),ICQNV,4)
!FGFG
!            IFLG(INBP) = KBITEC(IFLG(INBP),ICQNV, 5)
            IFLG(INBP) = KBITEC(IFLG(INBP),ICQUN,12)
            IFLG(INBP) = KBITEC(IFLG(INBP),IPART,14)
          ENDIF

        ENDDO PAR_BCLE

        INLV = INBP
        IRLN = NCILET + INLV*NCILBO

!  Copie de l'observation sur le fichier d'obs.

        IF ( INBP.GT.0 ) THEN

           write(wagon,fmt=wagon_prov) INBP
	   fmt_final = trim(adjustl(entete))//trim(adjustl(wagon))//")"

          WRITE (NULOBI,fmt_final) IRLN,IOTP,IOCH,ZLAT,ZLON,CLINDIC,
     &                     IDAT,IETM,ZALT,INLV,IRFL,ISTD,
     &                     (IVNM(J),ZPOB(J),ZPRL(J),ZVAR(J),
     &                     IFLG(J),J=1,INBP)
          KNBMECR = KNBMECR + 1
          KNBWAG  = KNBWAG + INBP

          IF ( L_GEOPOINTS ) THEN
            ITPM = MOD( IOCH , 1000 )
            WRITE (NULGEO,'(F11.5,F11.5,I5)') ZLON,ZLAT,ITPM
          ENDIF

          IF (LCUTOFF) THEN
             IDAT_PREC    = IDAT
             IETM_PREC    = IETM
             CLINDIC_PREC = CLINDIC
          ENDIF
        ENDIF

      ENDDO OBS_BCLE

!-----------------------------------------------------------------------

      RETURN
      END
